using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace HazmatMod
{
    public class HazmatMod
    {
		 public static void Main()
        {
			//NPCs SECTION
			
			//Hazmat NPC Variants
            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Yellow -HM",
                    DescriptionOverride = "Geiger Counter Equipped.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatYellowThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatyellowskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(145, 30, 30); 
			            person.SetSecondBruiseColor(60, 0, 0); 
			            person.SetThirdBruiseColor(30, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Medic -HM",
                    DescriptionOverride = "First Aid Kit Equipped.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatMedicThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatmedicskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(145, 30, 30); 
			            person.SetSecondBruiseColor(60, 0, 0); 
			            person.SetThirdBruiseColor(30, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
			            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit White -HM",
                    DescriptionOverride = "Geiger Counter Equipped.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatWhiteThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatwhiteskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(145, 30, 30); 
			            person.SetSecondBruiseColor(60, 0, 0); 
			            person.SetThirdBruiseColor(30, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
						            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Green -HM",
                    DescriptionOverride = "Geiger Counter Equipped.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatGreenThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatgreenskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(145, 30, 30); 
			            person.SetSecondBruiseColor(60, 0, 0); 
			            person.SetThirdBruiseColor(30, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
						            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Blue -HM",
                    DescriptionOverride = "Geiger Counter Equipped.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatBlueThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatblueskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(145, 30, 30); 
			            person.SetSecondBruiseColor(60, 0, 0); 
			            person.SetThirdBruiseColor(30, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
						            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Red -HM",
                    DescriptionOverride = "Geiger Counter Equipped.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatRedThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatredskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
												var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(145, 30, 30); 
			            person.SetSecondBruiseColor(60, 0, 0); 
			            person.SetThirdBruiseColor(30, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
			//Infected NPC Variants
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Infected Yellow -HM",
                    DescriptionOverride = "Looks like those suits don't stop bites...",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatZombYellowThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatzombieyellowskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatzombieflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        var person = Instance.GetComponent<PersonBehaviour>();
                        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
						ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Infected Tactical -HM",
                    DescriptionOverride = "Looks like that armor doesn't stop bites...",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatZombSpecOpsThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatzombiespecopsskin.png");
                        var flesh = ModAPI.LoadTexture("zombspecflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        var person = Instance.GetComponent<PersonBehaviour>();
                        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
									ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Infected Mars Explorer -HM",
                    DescriptionOverride = "Looks like those suits don't stop bites...",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatZombMarsThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatzombiemarsskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatzombieflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        var person = Instance.GetComponent<PersonBehaviour>();
                        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
						ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Infected White -HM",
                    DescriptionOverride = "Looks like those suits don't stop bites...",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatZombWhiteThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatzombiewhiteskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatzombieflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        var person = Instance.GetComponent<PersonBehaviour>();
                        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
									ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Infected Green -HM",
                    DescriptionOverride = "Looks like those suits don't stop bites...",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatZombGreenThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatzombiegreenskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatzombieflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        var person = Instance.GetComponent<PersonBehaviour>();
                        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
									ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Infected Blue -HM",
                    DescriptionOverride = "Looks like those suits don't stop bites...",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatZombBlueThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatzombieblueskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatzombieflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        var person = Instance.GetComponent<PersonBehaviour>();
                        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
									ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Infected Medic -HM",
                    DescriptionOverride = "Looks like those suits don't stop bites...",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatZombMedicThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatzombiemedicskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatzombieflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        var person = Instance.GetComponent<PersonBehaviour>();
                        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
									ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Infected Red -HM",
                    DescriptionOverride = "Looks like those suits don't stop bites...",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatZombRedThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatzombieredskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatzombieflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        var person = Instance.GetComponent<PersonBehaviour>();
                        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
												ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Mod Infected Soviet -HM",
                    DescriptionOverride = "Why Not?",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("SovietZombThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sovietzombieskin.png");
                        var flesh = ModAPI.LoadTexture("sovietflesh.png");
                        var bone = ModAPI.LoadTexture("sovietbone.png");
						Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        var person = Instance.GetComponent<PersonBehaviour>();
                        foreach(var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );
			//Unique NPCs
						            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Tactical Unit -HM",
                    DescriptionOverride = "Tactical Biohazard Response Unit.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatSpecOpsThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatspecopsskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						Transform child = Instance.transform.GetChild(5);
                        GameObject gameObject1 = new GameObject("SHINYEYE");
                        gameObject1.transform.SetParent(child);
                        gameObject1.transform.localPosition = new Vector3(0.0f, 0.0f);
                        gameObject1.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                        gameObject1.transform.localScale = new Vector3(1f, 1f);
                        SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                        spriteRenderer1.sprite = ModAPI.LoadSprite("SpecOpsEye.png", 1f, true);
                        spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                        spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        spriteRenderer1.sortingLayerName = "Top";
						
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(142, 30, 30); 
			            person.SetSecondBruiseColor(7, 0, 0); 
			            person.SetThirdBruiseColor(3, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Masked Human -HM",
                    DescriptionOverride = "Social Distancing in Style.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("MaskedHumanThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("maskedhumanskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);
                    }
                }
            );
			            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Unit Mars -HM",
                    DescriptionOverride = "Oxygen Tank Equipped.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazmatMarsThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("hazmatmarsskin.png");
                        var flesh = ModAPI.LoadTexture("hazmatflesh.png");
                        var bone = ModAPI.LoadTexture("hazmatbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(145, 30, 30); 
			            person.SetSecondBruiseColor(60, 0, 0); 
			            person.SetThirdBruiseColor(30, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
						            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Mod Alien -HM",
                    DescriptionOverride = "UFOs Inbound.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("AlienThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("alienskin.png");
                        var flesh = ModAPI.LoadTexture("alienflesh.png");
                        var bone = ModAPI.LoadTexture("alienbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(90, 240, 30); 
			            person.SetSecondBruiseColor(20, 50, 0); 
			            person.SetThirdBruiseColor(8, 20, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(0, 108, 4); 
                    }
                }
            );
						            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Mod Grey Alien -HM",
                    DescriptionOverride = "UFOs Inbound.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("AlienGreyThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("aliengreyskin.png");
                        var flesh = ModAPI.LoadTexture("alienflesh.png");
                        var bone = ModAPI.LoadTexture("alienbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(90, 240, 30); 
			            person.SetSecondBruiseColor(20, 50, 0); 
			            person.SetThirdBruiseColor(8, 20, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(0, 108, 4); 
                    }
                }
            );
						            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Hazmat Mod Soviet -HM",
                    DescriptionOverride = "Why Not?",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("SovietThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sovietskin.png");
                        var flesh = ModAPI.LoadTexture("sovietflesh.png");
                        var bone = ModAPI.LoadTexture("sovietbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(145, 30, 30); 
			            person.SetSecondBruiseColor(60, 0, 0); 
			            person.SetThirdBruiseColor(30, 0, 0); 
			            person.SetRottenColour(202, 199, 104); 
			            person.SetBloodColour(108, 0, 4); 
                    }
                }
            );
			//Non Human NPCs
									            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Gorse"),
                    NameOverride = "Fancy Gorse -HM",
                    DescriptionOverride = "Bowler Hat Equipped.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("FancyGorseThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("fancygorseskin.png");
                        var flesh = ModAPI.LoadTexture("fancygorseflesh.png");
                        var bone = ModAPI.LoadTexture("fancygorsebone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();
                    }
                }
            );
												            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Hazmat Mod Trash Bot -HM",
                    DescriptionOverride = "Abandoned, left with no purpose.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("TrashBotThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("trashbotskin.png");
                        var flesh = ModAPI.LoadTexture("trashbotflesh.png");
                        var bone = ModAPI.LoadTexture("trashbotbone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();
                    }
                }
            );
			//OBJECTS SECTION
						ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Red Barrel"),
                    NameOverride = "Hazard Barrel -HM",
                    NameToOrderByOverride = "Hazard Barrel",
                    DescriptionOverride = "Safety Is Guaranteed",
                    CategoryOverride = ModAPI.FindCategory("Explosives"),
                    ThumbnailOverride = ModAPI.LoadSprite("HazardBarrelThumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hazardbarrel.png", 1f);
                        Instance.FixColliders();
                    }
                }
            );
									ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"),
                    NameOverride = "Geiger Counter -HM",
                    NameToOrderByOverride = "Geiger Counter",
                    DescriptionOverride = "Safety Is Guaranteed",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("GeigerCounterThumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("geigercounter.png", 1f);
                        Instance.FixColliders();
                    }
                }
            );
									ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"),
                    NameOverride = "Fake Mustache (Pink) -HM",
                    NameToOrderByOverride = "Fake Mustache Pink",
                    DescriptionOverride = "Stylish",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("MustachePinkThumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("mustache_pink.png", 1f);
                        Instance.FixColliders();
                    }
                }
            );
									ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bowling Pin"),
                    NameOverride = "Fake Mustache (Black) -HM",
                    NameToOrderByOverride = "Fake Mustache Black",
                    DescriptionOverride = "Stylish.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("MustacheBlackThumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("mustache_black.png", 1f);
                        Instance.FixColliders();
                    }
                }
            );
												ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                    NameOverride = "Caution Rifle -HM",
                    NameToOrderByOverride = "Caution Rifle",
                    DescriptionOverride = "Safety Is Guaranteed",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("CautionRifleThumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("cautionrifle.png", 1f);
                        Instance.FixColliders();
                    }
                }
            );
			//godly NPCs
									            ModAPI.Register(
                 new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Gorse"),
                    NameOverride = "Gorsiplier -HM",
                    DescriptionOverride = "Mustache Equipped. Thanks for featuring my mod!",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("GorsiplierThumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("gorsiplierskin.png");
                        var flesh = ModAPI.LoadTexture("fancygorseflesh.png");
                        var bone = ModAPI.LoadTexture("fancygorsebone.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
						
						var person = Instance.GetComponent<PersonBehaviour>();
                    }
                }
            );
		}
    }
}